#access to the API
level = args[0]
callbacks = args[1]

#CUSTOM SAW
saw = level.objects.Find("saw")

original_saw_pos = saw.transform.position;
saw_pos = original_saw_pos

def update_saw():
    saw.transform.position = Vector3(original_saw_pos.x + Mathf.Sin(Time.time * Mathf.PI * 2) * 20, original_saw_pos.y, original_saw_pos.z)


#MULTI-STOP ELEVATOR
#configuring the stops to form a loop
elevator = level.objects.Find("elevator$").GetComponent("Door")
elevator_off_switch = level.objects.Find("elevator_switch$").GetComponent("Switch")
elevator_stops = Utils.SortByName(level.spawners.FindAll("elevator_stop[0-9]"))
max_stop = len(elevator_stops) - 1
current_door_cycle = 1

for i in range(0, max_stop):
    elevator.SetNextStop(elevator_stops[i].transform.position)

for i in range(0, max_stop):
    elevator.SetNextStop(elevator_stops[max_stop - i].transform.position)

#this processes the custom door cycle
def door_cycle():
    while 1: #infinite generator loop
        elevator.Open() #go to the next stop
        yield WaitForSeconds(2)


def stop_cycle(sender, data):
    global current_door_cycle
    
    current_door_cycle.Stop()

#CUSTOM INITIALIZATION
def start():
    global current_door_cycle
    #run final initialization after everything else is ready and the game is running (e.g. door.Open() starts working there)
    
    current_door_cycle = level.RunWave("cycle", door_cycle()) #use RunWave to run waves and coroutines (based on generators)
    Events.OnEvent(elevator_off_switch, "change_state", stop_cycle) #works for Switches, Triggers and Wires
    
    Debug.LogError("game started") #errors are visible in the game console

def update():
    update_saw()
    
callbacks.update = update
callbacks.start = start

Debug.LogError("it works")